###########################################################
#
# Copyright (c) 2005, Southpaw Technology
#                     All Rights Reserved
#
# PROPRIETARY INFORMATION.  This software is proprietary to
# Southpaw Technology, and is not to be reproduced, transmitted,
# or disclosed in any way without written permission.
#
#
#
__all__ = ["PlannerLayoutWdg"]

import os, types, re
import cStringIO

from pyasm.common import Xml, XmlException, Common, TacticException, Environment
from pyasm.biz import Schema, ExpressionParser, Project
from pyasm.search import Search, SearchKey, WidgetDbConfig
from pyasm.web import DivWdg, SpanWdg, HtmlElement, Table, Widget, Html, WebContainer
from pyasm.widget import WidgetConfig, WidgetConfigView, IconWdg

from tactic.ui.common import BaseRefreshWdg
from tactic.ui.container import SmartMenu, ResizableTableWdg

from panel_wdg import ViewPanelWdg

class PlannerLayoutWdg(BaseRefreshWdg):

    ARGS_KEYS = {
    }


    def get_display(my):
        top = my.top

        table = ResizableTableWdg()
        table.add_color("color", "color")
        top.add(table)
        table.add_row()


        element_names = ['preview','code','name']

        left_search_type = 'sthpw/login'
        left_view = 'planner_left'

        right_search_type = 'sthpw/login_group'
        right_view = 'planner_right'



        left = table.add_cell()
        left.add_border()
        left.add("Left")
        left_div = DivWdg()
        left_div.add_style("width: 100%")
        left_div.add_style("overflow-x: auto")
        left_div.add_style("height: 100%")
        left_div.add_style("min-height: 600px")
        left.add(left_div)
        left_layout = ViewPanelWdg(search_type=left_search_type, view=left_view, element_names=element_names)
        left_div.add(left_layout)

        middle = table.add_cell(resize=False)
        middle.add( my.get_middle_wdg() )

        right = table.add_cell()
        right.add_border()
        right.add("Right")
        right_div = DivWdg()
        right_div.add_style("width: 100%")
        right_div.add_style("overflow-x: auot")
        right.add_style("height: 100%")
        right.add_style("min-height: 600px")
        right.add(right_div)
        right_layout = ViewPanelWdg(search_type=right_search_type, view=right_view, element_names=element_names)
        right_div.add(right_layout)


        return top




    def get_middle_wdg(my):
        div = DivWdg()
        div.add("<---->")
        return div
